#include <stdio.h>
#include <string.h>
//#include <stdlib.h>
#define MAXLEN 1000 /*       */
#define MAXLINES 5000 /*   , 
    */
#define ALLOCSIZE 10000 /*     */
static char allocbuf[ALLOCSIZE]; /*   alloc */
static char *allocp = allocbuf; /*    */
char *lineptr[MAXLINES]; /*     */
int readlines(char *lineptr[], int nlines);
void writelines(char *lineptr[], int nlines);
double atof(const char *);
void qsort(void *lineptr[], int left, int right, int(*comp)(void *, void *));
int numcmp(char *, char *);
int main_Dcl();
int main_Undcl();

/*    */
int main_Sort(int argc, char *argv[]) {
	int nlines; /*      */
	int numeric = 0; /* 1,      */
	if (argc > 1 && strcmp(argv[1], "-n") == 0)
		numeric = 1;
	if ((nlines = readlines(lineptr, MAXLINES)) >= 0) {
		qsort((void**) lineptr, 0, nlines - 1,
				(int(*)(void*, void*)) (numeric ? numcmp : strcmp));
		writelines(lineptr, nlines);
		return 0;
	} else {
		printf("input too big to sort\n");
		return 1;
	}
}

/* numcmp:   si  s2 */
int numcmp(char *s1, char *s2) {
	double v1, v2;
	v1 = atof(s1);
	v2 = atof(s2);
	if (v1 < v2)
		return -1;
	else if (v1 > v2)
		return 1;
	else
		return 0;
}

/* getline:    s,    */
int getline(char s[], int lim) {
	int c, i;
	i = 0;
	while (--lim > 0 && (c = getchar()) != EOF && c != '\n')
		s[i++] = c;
	if (c == '\n')
		s[i++] = c;
	s[i] = '\0';
	return i;
}

char *alloc(int n) /*    n  */
{
	if (allocbuf + ALLOCSIZE - allocp >= n) { /*   */
		allocp += n;
		return allocp - n; /*    p */
	} else
		/*    */
		return 0;
}

void afree(char *p) /*  ,     */
{
	if (p >= allocbuf && p < allocbuf + ALLOCSIZE)
		allocp = p;
}

/* readlines:     */
int readlines(char *lineptr[], int maxlines) {
	int len, nlines;
	char *p, line[MAXLEN];
	nlines = 0;
	while ((len = getline(line, MAXLEN)) > 0)
		if (nlines >= maxlines || (p = alloc(len)) == NULL)
			return -1;
		else {
			line[len - 1] = '\0'; /*    */
			strcpy(p, line);
			lineptr[nlines++] = p;
		}
	return nlines;
}
/* writelines:     */
void writelines(char *lineptr[], int nlines) {
	while (nlines-- > 0)
		printf("%s\n", *lineptr++);
}

/* qsort:  v[left]...v[right]    */
void qsort(void *v[], int left, int right, int(*comp)(void *, void *)) {
	int i, last;
	void swap(void *v[], int, int);
	if (left >= right) /*   ,    */
		return; /* -    */
	swap(v, left, (left + right) / 2);
	last = left;
	for (i = left + 1; i <= right; i++)
		if ((*comp)(v[i], v[left]) < 0)
			swap(v, ++last, i);
	swap(v, left, last);
	qsort(v, left, last - 1, comp);
	qsort(v, last + 1, right, comp);
}

void swap(void *v[], int i, int j) {
	void *temp;
	temp = v[i];
	v[i] = v[j];
	v[j] = temp;
}

int main(int argc, char *argv[]) {
//	main_Sort(argc,argv);
	main_Dcl();
//	main_Undcl();

	return 0;
}
